clc
clear all
ResultsFile='ResultsParams.xlsx';
global sigma psi chi alpha gamma beta deltak deltad kappak kappad omega phi yBar T gs StatVars IfSave g Lens
global fks fds kdShock F_cc F_hh eta zs fws
MaxFunEvals=50000;
MaxIter=50;
gCase=1;  %   1 for gradual decline of G; 2 for actual stimulus; 3 for alt stimulus
options=optimset('Display','iter','MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter,'Algorithm','levenberg-marquardt','TolFun',.00000000001,'TolX',.000000001);
%  F_cc, F_hh, eta,  kappak, kappad, omega, phi, gCase, fkCase, fdCase, fShock,rho, kdShock]
beta=0.95^0.25;
r=1/beta-1;
deltak=0.0188;
deltad=0.0129;
alpha=0.646;
gamma=1;
params=[
%  Base case
    -0.5, 1.9,   .85 ,    8,      8,   1.03,0.82,   5,   2,      2,     .015,   0.6,    0.0;
    %  No complementarity
    -0.5, 1.9,   1,       8,      8,   1.03,0.82,   5,   2,      2,     .015,   0.6,    0.0;
    %  Less elastic labor supply
    -0.5, .7,    .85 ,    8,      8,   1.03,0.82,   5,   2,      2,     .015,   0.6,    0.0;
    %  No adjustment costs
    -0.5, 1.9,   .85 ,    0,      0,   1.03,0.82,   5,   2,      2,     .015,   0.6,    0.0;
    %  No markup effect
    -0.5, 1.9,   .85 ,    8,      8,   0,   0.82,   5,   2,      2,     .015,   0.6,    0.0;
    %  More persistent shcok
    -0.5, 1.9,   .85 ,    8,      8,   1.03,0.82,   5,   2,      2,     .015,   0.9,    0.0;
%  Different value of omega for ZLB case
%    -0.5, 1.9,   .85 ,    8,      8,   1.25,0.82,   5,   2,      2,     .015,   0.6,    0.0;
%  Different value of f for big shock case
 %   -0.5, 1.9,   .85 ,    8,      8,   1.03,0.82,   5,   2,      2,   .015*3,   0.6,    0.0;
%  Labor shock
%    -0.5, 1.9,   .85 ,    8,      8,   1.03,0.82,   5,   4,      1,.015*(r+deltak)/r,0.6,0.0;
%  Start with k and d above stationary levels
%   -0.5, 1.9,   .85 ,    8,      8,   1.03,0.82,   5,   1,      1,     0,       0.6,    0.1;
%  Different values of omega to calibrate to purchases multiplier
%   -0.5, 1.9,   .85 ,    8,      8,   1.0, 0.82,   1,   1,      1,     0    ,   0.6,    0.0;
%   -0.5, 1.9,   .85 ,    8,      8,   1.1, 0.82,   1,   1,      1,     0    ,   0.6,    0.0;
%   -0.5, 1.9,   .85 ,    8,      8,   1.2, 0.82,   1,   1,      1,     0    ,   0.6,    0.0;
%   -0.5, 1.9,   .85 ,    8,      8,   1.3, 0.82,   1,   1,      1,     0    ,   0.6,    0.0;
   ];
sz=size(params);
Ncase=sz(1);
Nparams=sz(2);
NVars=11;
Vars=[];
Stats=[];
for icase=1:Ncase
    np=1;
    F_cc=params(icase,np);
    np=np+1;
    F_hh=params(icase,np);
    np=np+1;
    eta=params(icase,np);
    np=np+1;
    kappak=params(icase,np);
    np=np+1;
    kappad=params(icase,np);
    np=np+1;
    omega=params(icase,np);
    np=np+1;
    phi=params(icase,np);
    np=np+1;
    gCase=params(icase,np);
    np=np+1;
    fkCase=params(icase,np);
    np=np+1;
    fdCase=params(icase,np);
    np=np+1;
    fShock=params(icase,np);
    np=np+1;
    rho=params(icase,np);
    np=np+1;
    kdShock=params(icase,np);
    T=160;  
    np=np+1;
    params(icase,np:np+5)=[beta,deltak,deltad,alpha,gamma,T];
    np=np+6;
    
    %  Static solution
    
    g=0.2;
    x=[1;8;1;4;.8;1;.5;1.9;0;0];
    discs=StatModel(x);
    
    MaxFunEvals=50000;
    MaxIter=500;
    options=optimset('Display','iter','MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter,'Algorithm','levenberg-marquardt','TolFun',.00000000001,'TolX',.000000001);
    xNew=fsolve(@StatModel,x,options);
    resNew=StatModel(xNew);
    yBar=xNew(1);
    sigma=xNew(7);
    psi=xNew(8);
    chi=xNew(9);
    F_ch=xNew(10);
    params(icase,np:np+3)=xNew(7:10)';
    Stats=[Stats;StatVars'];
    
    %  Dynamic solution
    
    %  The unknowns are values of y, h, w, q, and c for t=2:T,
    %  k for t=2:T-1, and r for t=3:T.
    %  Boundary conditions are for k in t=1 and T
    
%            1   2  3  4  5  6  7   8   9 10 11 12 13 14  15     16  17 18  19 20
%      Core: y  py  k  d  r  w  c  pk  pd
%      Aux                                 h qk qd  m mu
%      Other                                             invks invds gs vs fks fds z
    
    Lens=[ T-1,T-1,T-2,T-2,T-2,T-1,T-1,T-1,T-1];
    Loc=1;
    for var=1:numel(Lens)
        x(Loc:Loc+Lens(var)-1,1)=StatVars(var);
        Loc=Loc+Lens(var);
    end
    
    % Frictions
   
    fks=zeros(T,1);
    zs=ones(T,1);
    fws=zeros(T,1);
    switch fkCase
        
        case 2  %  Capital shock
            fk=fShock;
            for t=2:T
                fks(t)=fk;
                fk=fk*rho;
            end
            
        case 3  %  Markup shock
            fk=fShock;
            for t=2:T
                zs(t)=1+fk;
                fk=fk*rho;
            end
            
        case 4  %  Employment shock
            fw=fShock;
            for t=2:T
                fws(t)=fw;
                fw=fw*rho;
            end
    end
    fds=zeros(T,1);
    if fdCase==2
        fd=fShock;
        for t=2:T
            fds(t)=fd;
            fd=fd*rho;
        end
    end
    
    % Government purchases
    
    gsS=[0.0046;0.0046;0.0046;0.0046;0.0073;0.0073;0.0073;0.0073;0.0039;0.0039;0.0039;0.0039];
    switch gCase
        case 1  %  gradual decline
            Deltag0=0.01;
            Deltag=Deltag0;
            for t=2:T
                gs(t,1)=g+Deltag;
                Deltag=Deltag*phi;
            end
        case 2  %  actual stimulus
            gs=g+yBar*[0;gsS;zeros(T-13,1)];
        case 3 %  accelerated actual stimulus
            Deltag=1;
            lambda=.7^.25;
            for t=1:12
                gAdd(t,1)=Deltag;
                Deltag=Deltag*lambda;
            end
            gs(T,1)=g;
            gs(2:13)=g+gAdd*yBar*sum(gsS)/sum(gAdd);
        case 4  %  repayment to knock out wealth effect
            Deltag0=0.001;
            Deltag=Deltag0;
            for t=2:T
                gs(t,1)=g+Deltag;
                Deltag=Deltag*phi;
            end
            repay=beta^(-T+1)*Deltag0/(1-beta*phi);
            gs(T-1)=-repay;
        case 5 %  no change
            gs(1:T,1)=g;
    end
    
    IfSave=1;
    discs=CModel(x);
    load CModel AllVars
    xlswrite(ResultsFile,StatVars','Check','b2');
    xlswrite(ResultsFile,AllVars,'Check','b3');
    xlswrite(ResultsFile,discs,'Check','x3');
    xlswrite(ResultsFile,Stats,'Stationary','B2');
    xlswrite(ResultsFile,params,'Params','B2');

    MaxFunEvals=100000;
    MaxIter=100;
    IfSave=0;
    options=optimset('Display','iter','MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter,'Algorithm','levenberg-marquardt','TolFun',.00000000001,'TolX',.000000001);
    xN=fsolve(@CModel,x,options);
    
    %  Extract variables
    
    IfSave=1;
    Check=CModel(xN);
    IfSave=0;
    load CModel AllVars
    
    Vars=[Vars;AllVars];
    ys=AllVars(:,1);
    cs=AllVars(:,6);
end

xlswrite(ResultsFile,T,'Trajectories','A2');
xlswrite(ResultsFile,Vars,'Trajectories','B4');
xlswrite(ResultsFile,Stats,'Stats','B2');
