function discs=StatModel(x)

% TO DO: include the preference calibration in this function

global F_cc F_hh eta alpha gamma beta deltak deltad phi g StatVars

% Core:
% Variables: $y$, $k$, $w$, $d$, $c$, $p_y$


y=real(x(1));
k=real(x(2));
w=real(x(3));
d=x(4);
c=x(5);
py=x(6);
sigma=x(7);
psi=x(8);
chi=x(9);
F_ch=x(10);

% Auxiliary:
% \eq{(1+r)\beta=1}
% \eq{h = \alpha \frac{y}{w}}
% \eq{p_{k}=p_y(r+\delta_k)}
% \eq{p_{d}=p_y(r+\delta_d)}
% \eq{c_{s} = \phi \frac{c}{p_{y}}}
r=1/beta-1;
h=alpha*py*y/w;
pk=py*(r+deltak);
pd=py*(r+deltad);
cy=c*phi/py;
muc=c^(-1/sigma)*(1-chi*(1-1/sigma)*h^(1+1/psi));
muh=(-chi*(1+1/psi)*c^(1-1/sigma)-gamma)*h^(1/psi);
%            1   2  3  4  5  6  7   8   9 10 11 12 13 14  15     16  17  18  19 20  
%      Core: y  py  k  d  r  w  c  pk  pd
%      Aux                                 h qk qd cy  m  mu
%      Other                                                   invk invd g fks fds      
StatVars=[y;py;k;d;r;w;c;pk;pd;h;1;1;cy;beta;1;deltak*k;deltad*d;g;0;0]; 
% \eq{y=h^{\alpha}k^{1-\alpha}}
% \eq{(1 - \alpha) \frac{y}{p_{k}}=k}
% \eq{p_{d}d = (1-\phi) c}
% \eq{wc^{-1/\sigma}\left[1-\chi(1-1/\sigma)h^{1+1/\psi}\right]= p_{c}h^{1/\psi} \left[-\chi(1+1/\psi)c^{1-1/\sigma}-\gamma\right] }
% \eq{ y-c_s-g-\delta_k k -\delta_d d=0}
% \eq{1=\phi^{-\phi}(1-\phi)^{-(1-\phi)}p_y^{\phi}p_{d}^{1-\phi}}
discs(1)=y-h^alpha*k^(1-alpha);
discs(2)=k-(1-alpha)*py*y/pk;
discs(3)=pd*d-(1-phi)*c;
discs(4)=muh+w*muc;
discs(5)=cy+g+deltak*k+deltad*d-y;
discs(6)=1-phi^(-phi)*(1-phi)^(-(1-phi))*py^phi*pd^(1-phi);
H=1-chi*(1-1/sigma)*h^(1+1/psi);
C=chi*(1+1/psi)*c^(1-1/psi)+gamma;
P=(1-1/sigma)*(1+1/psi);
discs(7)=c^(-1/sigma)*H-(eta*c)^(-1/sigma);
discs(8)=-1-F_cc/sigma+chi*P*h^(1+1/psi)*F_ch/H;
discs(9)=-1+F_hh/psi+P*c^(1-1/sigma)*F_ch/C;
discs(10)=-F_ch/sigma-chi*P*h^(1+1/psi)*F_hh/H;